#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <memory.h>
#include "packet.h"
#include "inst78k.h"

#define	VERBOSE	0
#define	TRUE	1
#define	FALSE	0

/************************************************************************
 *	߃Zbge[u. (jjbN)
 ************************************************************************
 */
static	Inst inst78k[]=
{
#include "inst78t.h"
};

/************************************************************************
 *	Ɨ̈
 ************************************************************************
 */
static	Context ctx;		//ReNXg͗B.

extern	Uchar sample_bin[];


/************************************************************************
 *	߃R[ḧꕔ̃rbgtB[hςł鑮l̕\.
 ************************************************************************
 */
static	VariableCodes vtab[8]={
	{	1,	8,	0x07	,0	},	//_r_210   	WX^ԍ0`7      bit[2:0] or.
	{	2,	4,	0x06	,0	},	//_rp_21   	WX^yAԍ0`3  bit[2:1] or.
	{0x10,	8,	0x70	,0	},	//_b_654	rbgԍ0`7	      bit[6:4] or.
	{0x08,	8,	0x28	,0	},	//_rb_53	WX^oNԍ0`3bit[5,3] or.
	{0x10,	8,	0x70	,0	},	//_fa_765	callf ̏3bit	  bit[6:4] or.
	{	1,256,	0xff	,0	},	//_fa_low	callf ̏3bit	  bit[6:4] or.
	{	2, 32,	0x3e	,1	},	//_ta_54321	callt ̃e[uԍ  bit[4:0] or.
	{	1,256,	0xff	,0	} 	//_Saddr	8bitItZbg.
};

#if	0
short step_tab[8]={	//ϓ̂PZl.
//		r    rp  b       rb	  fa   low   ta	Saddr
		1	,2	,0x10	,0x08,0x10,1    ,2	,1	
	};
short cnt_tab[8]={	//ϓ̉Z\.
		8	,4	,8		,8	 ,8	  ,256	,32  ,255
	};
short mask_tab[8]={	//ϓ}XNp^ŕ\.
		0x07,0x06,0x70  ,0x28,0x70,0xff	,0x3e,0xff
	};
#endif


/************************************************************************
 *	WX^̃Xg.
 ************************************************************************
 */
const char *r_name[8]={
	"X","A","C","B","E","D","L","H"
};
const char *rp_name[4]={
	"AX","BC","DE","HL"
};

#if	0
0000H RESET POC, LVI, WDT 
0004H INTLVI  
0006H INTP0   
0008H INTP1   
000AH INTP2   
000CH INTP3   
000EH INTUSB0 
0010H INTUSB1 
0012H INTSRE6 
0014H INTSR6  
0016H INTST6   
0018H INTCSI10 
001AH INTTMH1 
001CH INTUSB2 
001EH INTTM50 
0020H INTTM000 
0022H INTTM010 
0024H INTRSUM 
002AH INTTM51 
003EH BRK 
#endif


/************************************************************************
 *	߃Zbge[u. oCgbNAbv\.
 ************************************************************************
 */
Inst *Lookup[256];	//QTU̖ߑ\.
//
Inst duptab[256];	//R[ḧ̕.
int	 dupidx=0;		//R[ȟ̕.


/************************************************************************
 *	_~[֐.
 ************************************************************************
 */
static int	IsOpt(int c)
{
	return 0;
}
/************************************************************************
 *	R[h̕.
 ************************************************************************
 */
Inst *Inst_dup(Inst *s)
{
	Inst *t = &duptab[dupidx++];
	*t = *s;
	return t;
}
/************************************************************************
 *
 ************************************************************************
 */
//
//	oCgbNAbv\ɁAPR[hǉ(Xg}).
//
void Inst_insert_1(Inst *p,int code)
{
	Inst *prev = Lookup[code];
	Inst *t;

	if(p->next != 0) {
#if	VERBOSE	
		printf("Warning already linked ptr %x\n",p->next);
#endif
		t = Inst_dup(p);
		t->next = prev;
		Lookup[code] = t;
		return;
	}

	p->next = prev;
	Lookup[code] = p;
}

/************************************************************************
 *	oCgbNAbv\ɁAKvR[hǉ(Xg}).
 ************************************************************************
 */
void Inst_insert(Inst *p)
{
	int code = p->opcode1 & 0x00ff;
	int attr = p->opcode1 & 0xff00;
	int step,cnt,n,i;

	if(attr & 0x1000) {
		n = (attr >> 8) & 7;
		step = vtab[n].step;
		cnt  = vtab[n].cnt;
		for(i=0;i<cnt;i++) {
#if	VERBOSE	
			printf(" iter Inst_insert_1(%x,%x) %s\n",p,code,p->mne);
#endif
			Inst_insert_1(p,code);
			code += step;
		}
	}else{	
#if	VERBOSE	
		printf("Inst_insert_1(%x,%x) %s\n",p,code,p->mne);
#endif
		Inst_insert_1(p,code);
	}
}

/************************************************************************
 *	߃bNAbv\̍쐬.
 ************************************************************************
 */
void Inst_init(void)
{
	Inst *p = inst78k;
	int i;
	for(i=0;i<256;i++) Lookup[i]=NULL;

	while(p->mne) {
		Inst_insert(p++);
	}	
}
#if	0
int	str_chk(char *t,char *s)
{
	while(*s) {
		if(*s != *t) return 1;
		s++;t++;
	}
}
#endif
/************************************************************************
 *	Iyhϊ.
 ************************************************************************
 *	strcmpɂAւ̃|C^r悤ɂ邩A
 *	nbV𓱓ق悢.
 *	ւ̃|C^Ŕr邽߂ɂ́AIyh\ɏoĂ镶
 *	B̃|C^ɂȂ悤ɏHv.
 *	i}N`ŏɓ̕wj
 */

//	͒PstrcmpŎĂ.
void conv_op(char *buf,char *op)
{
	char *t;
	if( strcmp(op,"r")==0 ) {
		strcpy(buf,r_name[ctx.r_210]);
		return;
	}
	if( strcmp(op,"rp")==0 ) {
		strcpy(buf,rp_name[ctx.rp_21]);
		return;
	}
	if( strcmp(op,"#byte")==0 ) {
		sprintf(buf,"#%s%02X%s", ctx.prefix ,ctx.Cbyte ,ctx.suffix );
		return;
	}
	if( strcmp(op,"#word")==0 ) {
		sprintf(buf,"#%s%02X%02X%s", ctx.prefix , ctx.Hibyte , ctx.Lowbyte ,ctx.suffix );
		return;
	}
	if( strcmp(op,"saddr")==0 ) {
		sprintf(buf,"%s%04X%s", ctx.prefix , ctx.Saddr ,ctx.suffix);
		return;
	}
	if( strcmp(op,"sfr")==0 ) {
		sprintf(buf,"%s%04X%s", ctx.prefix , ctx.Sfr   ,ctx.suffix);
		return;
	}
	if( strcmp(op,"saddr.bit")==0 ) {
		sprintf(buf,"%s%04X%s.%d", ctx.prefix, ctx.Saddr , ctx.suffix,ctx.b_654 );
		return;
	}
	if( strcmp(op,"sfr.bit")==0 ) {
		sprintf(buf,"%s%04X%s.%d", ctx.prefix, ctx.Sfr ,ctx.suffix ,ctx.b_654 );
		return;
	}
	if( strcmp(op,"[HL+byte]")==0 ) {
		sprintf(buf,"[HL+%s%02X%s]", ctx.prefix,ctx.Byte ,ctx.suffix);
		return;
	}
	if( strcmp(op,"RBn")==0 ) {
		sprintf(buf,"RB%d", ctx.rb_53);
		return;
	}
	if( op[0]=='!' ) {	// !addr16
		if( strcmp(op,"!addr16")==0 ) {
			sprintf(buf,"!%s%02X%02X%s", ctx.prefix, ctx.Hiaddr , ctx.Lowaddr , ctx.suffix);
			return;
		}
		if( strcmp(op,"!addr11")==0 ) {
			int addr11 = ( (ctx.fa_765 <<8) | ctx.fa_low ) + 0x800;
			sprintf(buf,"!%s%03x%s", ctx.prefix, addr11 , ctx.suffix);
			return;
		}
	}
	if( strcmp(op,"$addr16")==0 ) {
		sprintf(buf,"$%s%04X%s", ctx.prefix, ctx.jaddr + ctx.jdisp + 1,ctx.suffix);
		return;
	}
	if( strcmp(op,"[addr5]")==0 ) {
		sprintf(buf,"[$%s%02X%s]", ctx.prefix,ctx.ta_54321,ctx.suffix);
		return;
	}
	strcpy(buf,op);
	t = strchr(buf,'.');
	if(t) {
		sprintf( t ,".%d", ctx.b_654 );		//rbgԍ.
		return;
	}

}
/************************************************************************
 *	IyhWJ.
 ************************************************************************
 */
void expand_op(Inst *p,char *buf)
{
	buf[0]=0;

	if(p->op2) {
		conv_op(buf,p->op1);buf += strlen(buf);
		*buf++ = ',';
		conv_op(buf,p->op2);
		return;
	}
	if(p->op1) {
		conv_op(buf,p->op1);
		return;
	}
}

/************************************************************************
 *	Wrbg𕄍g.
 ************************************************************************
 */
int extend8(int disp)
{
	char d = disp;
	return d;
}
/************************************************************************
 *	WrbgSaddrAhX.
 ************************************************************************
 */
int extendSaddr(int disp)
{
	disp &= 0xff;
	if(disp < 0x20) {
		return 0xff00 + disp;
	}else{
		return 0xfe00 + disp;
	}
}
/************************************************************************
 *	WrbgSfrAhX.
 ************************************************************************
 */
int extendSfr(int disp)
{
	return 0xff00 + (disp & 0xff);
}
/************************************************************************
 *	R[h.
 ************************************************************************
 */
void expand_code(Inst *p,char *buf)
{
	buf[0]=0;
	char *t=buf;
	int i,code,opcode,attr;
	short *c = &p->opcode1;

	for(i=0;i<4;i++) {
		opcode = c[i];
		code = ctx.code[i];
		attr = opcode & 0xff00;
		if(attr == ___ ) break;		//I[.

		if(i!=0) *t++ = ',';
		switch(attr) {
		 case _Cbyte	 : //= 0x0200,	//萔.
			ctx.Cbyte = code;
			sprintf(t,"#Imm");break;
		 case _Byte	     : //= 0x0300,	//萔.
			ctx.Byte  = code;
			sprintf(t,"Byte");break;
		 case _Saddr	 : //= 0x0400,	//8bitItZbg.
			ctx.Saddr = extendSaddr(code);
			sprintf(t,"Saddr");break;
		 case _Sfr	     : //= 0x0500,	//8bitItZbg.
			ctx.Sfr = extendSfr(code);
			sprintf(t,"Sfr");break;
		 case _jdisp	 : //= 0x0600,	//fBXvCXg.
			ctx.jdisp = extend8(code);
			ctx.jaddr = ctx.adrs + i;
			sprintf(t,"Jdisp");break;
		 case _Lowaddr   : //= 0x0700,	//ʃAhX.
			ctx.Lowaddr = code;
			sprintf(t,"Lowaddr");break;
		 case _Hiaddr	 : //= 0x0800,	//ʃAhX.
			ctx.Hiaddr = code;
			sprintf(t,"Hiaddr");break;
		 case _Lowbyte   : //= 0x0900,	//ʒ萔.
			ctx.Lowbyte = code;
			sprintf(t,"LL");break;
		 case _Hibyte	 : //= 0x0a00,	//ʒ萔.
			ctx.Hibyte = code;
			sprintf(t,"HH");break;
		 case _fa_low	 : //= 0x1500,	//callf ̏3bit	  bit[6:4] or.
			ctx.fa_low = code;
			sprintf(t,"Fa_low");break;

		 case _r_210   	: //= 0x1000,	//WX^ԍ0`7      bit[2:0] or.
			ctx.r_210  = code & 7;		goto _def;
		 case _rp_21   	: //= 0x1100,	//WX^yAԍ0`3  bit[2:1] or.
			ctx.rp_21  = (code >>1) & 3;goto _def;
		 case _b_654	: //= 0x1200,	//rbgԍ0`7		  bit[6:4] or.
			ctx.b_654  = (code>>4) & 7;	goto _def;
		 case _rb_53	: //= 0x1300,	//WX^oNԍ0`3bit[5,3] or.
			ctx.rb_53  = ((code >>4) & 2) | ((code >>3) & 1);
										goto _def;
		 case _fa_765	: //= 0x1400,	//callf ̏3bit	  bit[6:4] or.
			ctx.fa_765  = code >> 5;	goto _def;
		 case _ta_54321	: //= 0x1600,	//callt ̃e[uԍ  bit[4:0] or.
			ctx.ta_54321  = ((code>>1) & 0x1f) * 2 + 0x40;goto _def;

		 default:
_def:
			sprintf(t,"%02X",opcode & 0xff);break;
		}
		t+=strlen(t);
	}
	
}

/************************************************************************
 *	߃R[h񂪌㑱邩ǂ̔i㑱ȂꍇAsj
 ************************************************************************
 */
int Inst_IsReturn(Inst *p)
{
	if(p->mne[0]=='R') {
		if(strcmp(p->mne,"RET") ==0) return 1;
		if(strcmp(p->mne,"RETB")==0) return 1;
		if(strcmp(p->mne,"RETI")==0) return 1;
	}
	if(strcmp(p->mne,"BR")  ==0) return 1;
	return 0;
}

/************************************************************************
 *	ߗ dw Ƃĉ߂.
 ************************************************************************
 */
int	Inst_dump_dw(char *buf)
{
	int dw = ctx.code[0] | (ctx.code[1] << 8);
	
	sprintf(buf,"%-5s %s%04X%s", "DW" , ctx.prefix,dw , ctx.suffix);
	strcpy(ctx.rembuf,"VectorTable");

	return 2;	// dw ͂QoCgŒ.
}

/************************************************************************
 *	ߗ db Ƃĉ߂.
 ************************************************************************
 */
int	Inst_dump_db(char *buf)
{
	int db = ctx.code[0];
	
	sprintf(buf,"%-5s %s%02X%s", "DB" , ctx.prefix, db , ctx.suffix);
	strcpy(ctx.rembuf,"OptionByte,OnChipSecurity");

	return 1;	// db ͂PoCgŒ.
}

/************************************************************************
 *	߃R[h̃_v::m肵߃R[hɑ΂.
 ************************************************************************
 */
int	Inst_dump_1(char *buf,Inst *p)
{
	char op[256];
	char code[256];

	expand_code(p,code);
	expand_op(p,op);

	if(ctx.debugf & MODE_DEBUG_INFO) {
		sprintf(buf,"%-5s %-18s ;%s",p->mne,op,code);
	}else{
		sprintf(buf,"%-5s %s",p->mne,op);
	}

	if( Inst_IsReturn(p) ) {strcat(buf,"\n");}

	return p->bytes;
}

/************************************************************************
 *	SẴGg[̖߃R[h_vBe[umFp.
 ************************************************************************
 */
void Inst_dump(void)
{
	Inst *p;
	char buf[256];
	int i;
	for(i=0;i<256;i++) {
		printf("Code[ 0x%02X ] :\n",i);
		p = Lookup[i];
		while(p) {
			Inst_dump_1(buf,p);
			printf("%s\n",buf);
			p = p->next;
		}	
	}
}

/************************************************************************
 *	ߌꂪ}b`OĂ邩Tu[`.
 ************************************************************************
 *	͂QoCgڂ܂Ń}b`ĂꍇɌRoCgڂ̓ꏈ.
 *	Ɖ.
 */
int Inst_match3(Inst *p)
{
	if( p->opcode3 == 0x1e ) {	// PSWn͂RoCgڂ 0x1e߂ƂȂ.
		if( p->opcode3 == ctx.code[2]) return 1;	// PSW Ɉv.
		return 0;	// ̑.
	}
	return 1;		// PSWnł͂Ȃ̂ŁAʏ̈v.
}
/************************************************************************
 *	ߌꂪ}b`OĂ邩.
 *	߂ɂẮARoCgڂ 0x1e ܂Ń`FbNKv炵.
 ************************************************************************
 */
int Inst_match(Inst *p)
{
	// }b`́AȂƂQoCg߂ɂȂ.
	int code = p->opcode2;		//oCg.
	int attr = code & 0xff00;

	// oCg̈v.
	if( code == ctx.code[1]) return Inst_match3(p);

	// ORp^[݂ꍇA}XNďƍ.	
	if(attr & 0x1000) {
		int n = (attr >> 8) & 7;
		int mask = (vtab[n].mask ^ 0xff);
//		printf(" mask = %x[%d] %x code=%x",vtab[n].mask ^ 0xff,n	,code,ctx.code[1] );
		if( (code & 0xff) == (ctx.code[1] & mask)) return Inst_match3(p);
	}
	return 0;
}


/************************************************************************
 *	(*s) ̑啶SďɕϊB
 ************************************************************************
 */
void ToLowers(char *s)
{
	while(*s) {
		*s = tolower(*s);
		s++;
	}
}


/************************************************************************
 *	Ps::tAZu.
 ************************************************************************
 */
int	Disasm_Line(char *buf,Uchar *bin,int addr,int debugf)
{
	Inst *p;
	int c = *bin;
	
	//ReNXgSNA.
	memset( (void*) &ctx,0,sizeof(ctx));

	//Kvȏn.
	ctx.adrs = addr;
	ctx.debugf = debugf;
	memcpy( ctx.code,bin,4);
	if(debugf & MODE_HEX_SUFFIX) {
		strcpy( ctx.suffix , "H" );
	}else{
		strcpy( ctx.prefix , "0x" );
	}

	//xN^[e[ȕꍇI dw ɂ.
	if(( addr >=0 ) && (addr < 0x80 )) {
		return Inst_dump_dw(buf);
	}
	if(( addr >=0x80 ) && (addr <= 0x8e )) {
		return Inst_dump_db(buf);
	}
	if(( addr >=0x1080 ) && (addr <= 0x108e )) {
		return Inst_dump_db(buf);
	}

	p = Lookup[c];

	if( p ) {
		if( p->next == NULL ) {	//	}b`O͂P.
			return Inst_dump_1(buf,p);
		}

		// Ƀ}b`Ă.
		while(p) {
#if	VERBOSE
			char tmp[256];
			Inst_dump_1(tmp,p);
			printf("check : %s \n",tmp);
#endif
			if( Inst_match(p) ) {	//QoCgڂŃ}b`O.
				return Inst_dump_1(buf,p);
			}
			p = p->next;
		}
	}	
	sprintf(buf,"???");
	return 1;			// dummy size Ԃ.
}

/************************************************************************
 *	PUi_v.
 ************************************************************************
 */
void Disasm_Hex(char *hexbuf,Uchar *bin,int off,int opsize)
{
	int i;
	
	sprintf(hexbuf,"%04X",off);hexbuf += strlen(hexbuf);
	for(i=0;i<opsize;i++,bin++) {
		sprintf(hexbuf," %02X",*bin);hexbuf += strlen(hexbuf);
	}
}

/************************************************************************
 *	tAZu.
 ************************************************************************
 */
void Disasm(Uchar *bin,int addr,int size)
{
	int opsize;
	int off = addr;

	while( off < (addr+size)) {
		opsize = Disasm_Line(ctx.disbuf,bin,off,TRUE);
		 		 Disasm_Hex( ctx.hexbuf,bin,off,opsize);

		if(!IsOpt('u')) {
			ToLowers(ctx.disbuf);
			ToLowers(ctx.hexbuf);
		}
		if(ctx.rembuf[0]) {
			printf("%-16s %-18s ;%s\n", ctx.hexbuf,ctx.disbuf,ctx.rembuf);
		}else{
			printf("%-16s %s\n", ctx.hexbuf,ctx.disbuf);	// 4+3*4=16
		}
		off += opsize;
		bin += opsize;
	}
}

/************************************************************************
 *
 ************************************************************************
 */

