/**********************************************************************
	g[r^CegdwtH[}bgoCi[.
 **********************************************************************
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "packet.h"

//	[N.
static	unsigned char 	databuf[256];	//oCi[ꂽoCg.
static	int				dataidx;		//databuf[] LoCg.

/**********************************************************************
 *	( *s ) Q̂PUiƂ݂ȂāAlɕϊ.
 **********************************************************************
 *	ϊɐ 0`0xff ̐lԂ.
 *		sꍇ -1 Ԃ.
 */
static int read_hex1(char *s)
{
	char buf[16];
	int rc = -1;

	buf[0] = s[0];
	buf[1] = s[1];
	buf[2] = 0;
	sscanf(buf,"%x",&rc);
	return rc;
}

/**********************************************************************
 *	( *s ) Q̂PUi񂾕ƂāA
 *	oCg databuf[] (O[oz) ɕϊB
 **********************************************************************
 *	ϊꂽoCg̗LoCg dataidx (O[oϐ)ɓ.
 */
static int read_hex(char *s)
{
	int rc;

	dataidx = 0;
	while(*s) {
		rc = read_hex1(s);s+=2;
		if(rc<0) return rc;
		databuf[dataidx++]=rc;
	}
	return 0;
}

/**********************************************************************
 *	rR[hoCgɕϊ.
 **********************************************************************
 *	ϊrR[h S1,S2,S3 ̂ꂩɌ.
 */
int	srec(Packet *p,int adrsize,unsigned char *buf,int length)
{
	int recsize;
	int adrs=0;
	int cnt;
	int i;
	recsize = *buf++;
	for(i=0;i<adrsize;i++) {
		adrs <<= 8;
		adrs |= *buf++;
	}
	cnt = recsize - adrsize - 1;
	
	if( recsize != (length-1) ) {
		printf("WARNING:record length mismatch:%d != %d\n",recsize,(length-1));
	}

	memcpy(p->bindata,buf,cnt);

	p->adrs = adrs;
	p->size = cnt;
	p->off  = 0;

#if	0
	printf("%06x",adrs);
	for(i=0;i<cnt;i++) {
		printf(" %02x",buf[i]);
	}
	printf("\n");
#endif

	return cnt;
}


/**********************************************************************
 *		
 **********************************************************************
 0 1 2 3 4
:1000100084C083C082C081C080C07FC07EC07DC0DC
 ~~ f[^
   ~~~~ AhX
       ~~ R[h^Cv
         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~f[^ 
                                         ~~`FbNT.
 */

/**********************************************************************
 *	CegdwoCgɕϊ.
 **********************************************************************
 *
 *	ϊɐꍇ́AǂݎoCgԂ.
 *		  sꍇ͂OԂ.
 *
 *	ꍇ́APacket \̂ɁA擾f[^.
 */
int Read_IntelHex(Packet *p , char *linebuf)
{
	int len,adrs,type;

	if(linebuf[0] != ':') return 0;

	read_hex(linebuf+1);	// ':' ȉ̂PUioCgf[^ɕϊ.

	len  = databuf[0];
	adrs =(databuf[1]<<8)|databuf[2];
	type = databuf[3];

	if(type == 0) {
		p->adrs = adrs;
		p->size = len;
		p->off  = 0;
		memcpy(p->bindata,databuf+4,len);
		return len;
	}
	return 0;
}
/**********************************************************************
 *	rR[hoCgɕϊ.
 **********************************************************************
 *	ϊrR[h S1,S2,S3 ̂ꂩɌ.
 *
 *	ϊɐꍇ́AǂݎoCgԂ.
 *		  sꍇ͂OԂ.
 *
 *	ꍇ́APacket \̂ɁA擾f[^.
 */
int Read_Srecord(Packet *p , char *linebuf)
{
	int scmd;
	if(linebuf[0] != 'S') return 0;
	scmd = linebuf[2];

	read_hex(linebuf+2);	// ':' ȉ̂PUioCgf[^ɕϊ.

	switch(scmd) {
		case '0':
			break;
		case '1':	return srec(p,2,databuf,dataidx);
		case '2':	return srec(p,3,databuf,dataidx);
		case '3':	return srec(p,4,databuf,dataidx);

		case '7':
		case '8':
		case '9':
			break;
	}
	return 0;

}
